#include "queue.h"

///   front   ...         rear      ݷ ->
/* е˳洢ṹ(ѭ) */

can_queue_tag can_tx_queue;
can_queue_tag can_rx_queue;

/****************************************************
 *    init_queue
 *  ܣʼ
 *  ڲ
 *  ˵    
 ****************************************************/
void queue_init(p_can_queue_tag p_queue)
{                                      /* һնQ */
    p_queue->head = p_queue->tail = 0; /*ն*/
    p_queue->count                = 0;
}

/****************************************************
 *    is_queue_empty
 *  ܣѯǷΪ
 *  ڲQ 
 *  ˵    նУSUCCESS򷵻ERROR
 ****************************************************/
uint8_t queue_empty(p_can_queue_tag p_queue)
{ /* */
    return p_queue->count == 0;
}

uint8_t queue_full(p_can_queue_tag p_queue)
{ /* */
    return p_queue->count == MAX_QSIZE;
}

/****************************************************
 *    queue_length
 *  ܣʼ
 *  ڲQ 
 *  ˵    
 ****************************************************/
uint16_t queue_length(can_queue_tag p_queue)
{ /* QԪظеĳ */
    return (p_queue.tail - p_queue.head + MAX_QSIZE) % MAX_QSIZE;
}

/****************************************************
 *    get_head
 *  ܣȡͷ
 *  ڲQ 
 *  ˵    
 ****************************************************/
uint8_t get_head(
    can_queue_tag *p_queue,
    pdu_tag       *e)
{                                       /* вգeQĶͷԪأOK򷵻ERROR*/
    if (p_queue->head == p_queue->tail) /* п */
        return Q_ERR;
    *e = p_queue->can_message[p_queue->head];

    p_queue->head = (p_queue->head + 1) % MAX_QSIZE;
    return Q_OK;
}

/****************************************************
 *    insert_queue
 *  ܣв
 *  ڲQ     e 
 *  ˵    
 ****************************************************/
QUEUE_STATUS en_queue(p_can_queue_tag p_queue,
                      pdu_tag         data)
{
    if (queue_full(p_queue))
        return Q_FULL;
    p_queue->count++;
    p_queue->can_message[p_queue->head] = data;
    p_queue->head                       = (p_queue->head + 1) % MAX_QSIZE;
    return Q_OK;
    /* ԪeΪQµĶβԪ */
    // if ((p_queue->tail + 1) % MAX_QSIZE == p_queue->head) /*  */
    //     return ERROR;
    // p_queue->can_message[p_queue->tail] = e;
    // p_queue->tail                       = (p_queue->tail + 1) % MAX_QSIZE;
    // return SUCCESS;
}

QUEUE_STATUS de_queue(p_can_queue_tag p_queue,
                      pdu_tag         data)
{ /* ԪeΪQµĶβԪ */
    // if ((p_queue->tail + 1) % MAX_QSIZE == p_queue->head) /*  */
    //     return ERROR;
    // p_queue->can_message[p_queue->tail] = e;
    // p_queue->tail                       = (p_queue->tail + 1) % MAX_QSIZE;
    // return SUCCESS;
    if (queue_empty(p_queue))
        return Q_EMPTY;
    data          = p_queue->can_message[p_queue->tail];
    p_queue->tail = (p_queue->tail + 1) % MAX_QSIZE;
    p_queue->count--;

    return Q_OK;
}