#ifndef __DEV_AT24CXX_H
#define __DEV_AT24CXX_H

#include "hal_i2c1.h"

#define bool uint8_t

#define I2C1_NAME I2C1
// #define I2C1_DEVICE_IS_EEPROM 1

#define MAX_SIZE   512
#define PAGES      512
#define PAGESIZE   8
#define BLOCK_SIZE 512
///**********************************

#define NULL 0

int32_t dev_at24cxx_read_bytes(uint8_t addr, uint8_t *buf, uint8_t size);
int32_t dev_at24cxx_write_bytes(uint8_t addr, uint8_t *buf, uint8_t size);

#endif // __DEV_AT24CXX_H