#ifndef __DEV_LED_H
#define __DEV_LED_H

#include <stdint.h>
typedef union
{
    struct
    {
        uint8_t led0_state_flag : 1;
        uint8_t led1_state_flag : 1;
        uint8_t led2_state_flag : 1;
        uint8_t led3_state_flag : 1;
        uint8_t led4_state_flag : 1;
        uint8_t led5_state_flag : 1;
        uint8_t led6_state_flag : 1;
        uint8_t led7_state_flag : 1;
    } bits;
    uint8_t led_all_state;
} dev_led_state_t;

typedef struct
{
    dev_led_state_t dev_led_state;
    uint8_t         i;
} dev_led_t;

extern dev_led_t dev_led;

void dev_led_on_off(uint8_t leds, uint8_t on_off);

#endif // __DEV_LED_H