#ifndef __DEV_TASK_H
#define __DEV_TASK_H

#include "stm32f4xx.h"

#define TASK_MASK_QTY 8

typedef union
{
    struct
    {
        uint8_t task0_flag : 1;
        uint8_t task1_flag : 1;
        uint8_t task2_flag : 1;
        uint8_t task3_flag : 1;
        uint8_t task4_flag : 1;
        uint8_t task5_flag : 1;
        uint8_t task6_flag : 1;
        uint8_t task7_flag : 1;
    } bits;
    uint8_t all;
} dev_task_flag_un;

void dev_task_clock(void);

extern dev_task_flag_un dev_task_flag;

#endif // __DEV_TASK_H
